﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace TestHarnessCSharp
{
    class Program
    {
        public static bool APLNotifyFired;
        static void Main(string[] args)
        {
            Console.WriteLine("C# Calling APL+Win");
            APLNotifyFired = false;
            BSSI.APLWinNet35.APLWinInterface apl = new BSSI.APLWinNet35.APLWinInterface();
            apl.APLNotify += new BSSI.APLWinNet35.APLWinInterface.APLNotifyHandler(apl_APLNotify);
            apl.Visible = 1;
            string wspath = System.IO.Path.GetFullPath(@"..\..\APL+WIN\CALLAPLWINFROMVISUALAPL.W3");
            try
            {
                apl.APLWorkspaceLoad(wspath);
                Console.WriteLine("Enter a numeric value: ");
                double input = Convert.ToDouble(Console.ReadLine());
                double result = Convert.ToDouble(apl.Call1("SquareRoot", input));
                if (!APLNotifyFired)
                {
                    Console.WriteLine("Square root of " + input.ToString() + ": " + result.ToString());
                }
            }
            catch (Exception e)
            {
                if (!APLNotifyFired)
                {
                    Console.WriteLine(e.Message);
                }
            }
            Console.WriteLine("Click the Enter key to end this application");
            Console.ReadLine();
            apl.Visible = 0;
            apl.Close();
        }

        static void apl_APLNotify(object sender, BSSI.APLWinNet35.APLNotifyEventArgs e)
        {
            Console.WriteLine("APLNotify Code: " + e.Code.ToString());
            Console.WriteLine("APLNotify Data: " + e.Data.ToString());
            e.Result = "Message from calling environment back to APL+Win";
            Console.WriteLine("APLNotify Result: " + e.Result.ToString());
            APLNotifyFired = true;
        }
    }
}
