#region Using directives
using System;
using System.Collections.Generic;
using System.Text;
using BSSI.APLWinNet35;
#endregion

namespace TestHarnessVisualAPL{
	public class Program{
	    public static APLNotifyFired;
		public static void Main(){
			Console.WriteLine("Use APL+Win from VisualAPL");
            APLNotifyFired = 0;
            BSSI.APLWinNet35.APLWinInterface apl = new BSSI.APLWinNet35.APLWinInterface();
            apl.APLNotify += apl_APLNotify;
            apl.Visible = 1;
            string wspath = System.IO.Path.GetFullPath(@"..\..\APL+WIN\CALLAPLWINFROMVISUALAPL.W3");
            try {
                apl.APLWorkspaceLoad(wspath);
                Console.WriteLine("Enter a numeric value: ");
                double input = Convert.ToDouble(Console.ReadLine());
                double result = Convert.ToDouble(apl.Call1("SquareRoot", input));
                :IF ~APLNotifyFired
                    Console.WriteLine("Square root of " + input.ToString() + ": " + result.ToString());
                :ENDIF
            } catch (Exception e) {
                :IF ~APLNotifyFired 
                    Console.WriteLine(e.Message);
                :ENDIF
            }
            Console.WriteLine("Click the Enter key to end this application");
            Console.ReadLine();
            apl.Visible = 0;
            apl.Close();
        }

        public static void apl_APLNotify(object sender, APLNotifyEventArgs e) {
            Console.WriteLine("APLNotify Code: " + e.Code.ToString());
            Console.WriteLine("APLNotify Data: " + e.Data.ToString());
            e.Result = "Message from calling environment back to APL+Win";
            Console.WriteLine("APLNotify Result: " + e.Result.ToString());
            APLNotifyFired = 1;
        }
	}
}